﻿
Option Explicit On

Imports System
Imports System.Data
Imports System.Data.SqlClient
Imports System.IO
Imports System.Security

Public Class Form1

    Private Sub btn_findMovie_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_findMovie.Click
        OpenFileDialog1.ShowDialog()
        tb_movieData.Text = OpenFileDialog1.FileName
    End Sub

    Private Sub btn_saveDir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_saveDir.Click
        FolderBrowserDialog1.ShowDialog()
        tb_saveDir.Text = FolderBrowserDialog1.SelectedPath
    End Sub

    Public Class LargeObjectBinary
        Private Const bufferSize As Integer = 4096 '네트워크 패킷 사이즈 (디폴트로 설정됨)
        Private connectionString As String

        Public Sub New(ByVal dataSource As String)
            ' DB연결 문자열을 생성함 (DB는 FStreamDB를 사용)
            connectionString = "data source=" + dataSource + ";initial catalog=FStreamDB;user=vbUser;password=1234"
        End Sub

        ' 데이터베이스로부터 대용량 이진데이터를 읽어서 사용자컴퓨터의 파일로 저장함.
        Public Sub GetDocumentFromDatabase(ByVal documentId As Int32, ByVal userDirectory As String)
            Dim sqlReader As SqlDataReader = Nothing
            Dim fileName As String '저장할 파일명
            Dim movieName As String ' 영화제목

            Using sqlConn As New SqlConnection(connectionString)

                '*************************************
                ' 영화일련번호에 해당하는 영화파일명/제목을 얻는다.
                ''*************************************
                sqlConn.Open()
                Using sprocCommand As New SqlCommand("[dbo].[usp_GetMovieFileName]", sqlConn)
                    sprocCommand.CommandType = CommandType.StoredProcedure
                    sprocCommand.Parameters.Add(New SqlParameter("@mNumber", SqlDbType.Int))
                    sprocCommand.Parameters(0).Value = documentId

                    sqlReader = sprocCommand.ExecuteReader(CommandBehavior.SequentialAccess)
                    sqlReader.Read()

                    fileName = sqlReader.GetString(0) ' 저장프로시저의 1번째는 fileName
                    fileName = userDirectory + "\" + fileName ' 저장디렉토리 + 파일이름
                    movieName = sqlReader.GetString(1) ' 저장프로시저의 2번째는 movieName
                    sqlReader.Close()
                End Using
                sqlConn.Close()

                '*************************************
                ' 영화일련번호에 해당하는 데이터를 얻는다.
                '*************************************
                sqlConn.Open()
                Using sprocCommand As New SqlCommand("[dbo].[usp_GetMovieData]", sqlConn)
                    sprocCommand.CommandType = CommandType.StoredProcedure
                    sprocCommand.Parameters.Add(New SqlParameter("@mNumber", SqlDbType.Int))
                    sprocCommand.Parameters(0).Value = documentId

                    Try
                        sqlReader = sprocCommand.ExecuteReader(CommandBehavior.SequentialAccess)
                        sqlReader.Read()
                        Using fileStream As New FileStream(fileName, FileMode.Create, FileAccess.Write)
                            Using binaryWriter As New BinaryWriter(fileStream)

                                Dim outbyte(bufferSize) As Byte
                                Dim startIndex As Long = 0
                                Dim retval As Long = sqlReader.GetBytes(0, startIndex, outbyte, 0, bufferSize)
                                While retval = bufferSize
                                    binaryWriter.Write(outbyte, 0, CInt(retval))
                                    startIndex += bufferSize
                                    retval = sqlReader.GetBytes(0, startIndex, outbyte, 0, bufferSize)
                                End While

                                binaryWriter.Write(outbyte, 0, CInt(retval))
                            End Using
                        End Using
                    Finally
                        sqlReader.Close()
                    End Try
                End Using
                sqlConn.Close()
            End Using

            MsgBox("영화(" + movieName + ")가 " + fileName + "로 저장됨", MsgBoxStyle.OkOnly, "성공")
        End Sub

        ' 이진파일을 데이터베이스에 저장함.
        Public Sub InsertDocument(ByVal movieName As String, ByVal datafilesDirectory As String, ByVal fileName As String, ByVal fileExtension As String)
            ' 주의 : 입력 파일의 최대 크기는 2GB
            Dim fullFileName As String = datafilesDirectory + "\" + fileName
            Dim bytes As Byte() = ReadFile(fullFileName)
            Dim sqlConn As New SqlConnection(connectionString)
            Try
                Dim sprocCommand As New SqlCommand("[dbo].[usp_InsertMovie]", sqlConn)
                Try
                    sqlConn.Open()
                    sprocCommand.CommandType = CommandType.StoredProcedure

                    sprocCommand.Parameters.Add(New SqlParameter("@movieName", SqlDbType.NVarChar, 100))
                    sprocCommand.Parameters(0).Value = movieName

                    sprocCommand.Parameters.Add(New SqlParameter("@movieData", SqlDbType.VarBinary))
                    sprocCommand.Parameters(1).Value = bytes

                    sprocCommand.Parameters.Add(New SqlParameter("@FileName", SqlDbType.NVarChar, 100))
                    sprocCommand.Parameters(2).Value = fileName

                    sprocCommand.Parameters.Add(New SqlParameter("@FileExtension", SqlDbType.NVarChar, 8))
                    sprocCommand.Parameters(3).Value = fileExtension

                    ' 대용량 파일의 업로드시에 타임아웃을 시간제한을 없앰
                    sprocCommand.CommandTimeout = 0
                    sprocCommand.ExecuteNonQuery()
                Finally
                    sprocCommand.Dispose()
                End Try
            Finally
                sqlConn.Dispose()
            End Try
        End Sub

        Private Shared Function ReadFile(ByVal fileName As String) As Byte()
            Using binaryReader As New BinaryReader(CType(File.OpenRead(fileName), Stream), System.Text.Encoding.ASCII)

                Dim fileSize As Long = binaryReader.BaseStream.Length
                Dim bytes() As Byte = New Byte(CInt(fileSize)) {}
                binaryReader.Read(bytes, 0, CInt(fileSize))
                Return bytes
            End Using
        End Function
    End Class





    ' *********************************************************************
    ' 영화파일을 업로드 하는 메인 서브루틴
    ' *********************************************************************
    Sub uploadMovie()

        ' 선택한 파일로 부터 정보를 추출한다.
        Dim inputFileInfo As New FileInfo(tb_movieData.Text)
        Dim inFileName As String = inputFileInfo.Name ' 파일이름
        Dim inExtName As String = inputFileInfo.Extension ' 파일확장자

        Dim datafilesDirectory As String = inputFileInfo.DirectoryName ' 파일이 존재하는 폴더
        Dim dataSource As String = "." ' 데이터소스 (로컬서버)
        Dim largeObjectBinary As New LargeObjectBinary(dataSource)

        ' 영화제목, 영화데이터파일, 파일이름, 확장명으로 Insert하기 위한 프로시져를 호출한다.
        largeObjectBinary.InsertDocument(tb_movieName.Text, datafilesDirectory, inFileName, inExtName)

        ' DB에 업로드가 완료되면 완료 메시지를 출력한다.
        MsgBox("파일이 DB에 업로드됨", MsgBoxStyle.OkOnly, "성공")
    End Sub

    ' *********************************************************************
    ' 영화파일을 다운로드하는 메인 서브루틴
    ' *********************************************************************
    Sub downloadMovie()

        Dim movieNum As Integer
        Dim saveDir As String

        movieNum = tb_movieNum.Text
        saveDir = tb_saveDir.Text

        Dim dataSource As String = "." ' 데이터소스 (로컬서버)
        Dim largeObjectBinary As New LargeObjectBinary(dataSource)

        largeObjectBinary.GetDocumentFromDatabase(movieNum, saveDir)
    End Sub

    Private Sub btn_Upload_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_Upload.Click

        If tb_movieName.Text = "" Or tb_movieData.Text = "" Then
            MsgBox("영화제목 / 영화파일 모두를 입력해야 함", MsgBoxStyle.Critical, "경고")
            Exit Sub
        End If

        uploadMovie()
    End Sub


    Private Sub btn_download_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btn_download.Click
        If tb_movieNum.Text = "" Or tb_saveDir.Text = "" Then
            MsgBox("영화일련번호 / 저장할 폴더 모두를 입력해야 함", MsgBoxStyle.Critical, "경고")
            Exit Sub
        End If

        downloadMovie()
    End Sub
End Class
